Attribute VB_Name = "modDirectXError"
Private Const DDERR_NOTINITIALIZED As Long = &H800401F0

Public Sub DDERROR(ByVal ErrorCode As Long, _
                   ByVal ErrorTitle As String, _
                   ByVal ErrorFlag As Boolean)
Dim em As String
On Error Resume Next

Select Case ErrorCode
  Case DDERR_ALREADYINITIALIZED
  em = "The object has already been initialized."
  Case DDERR_BLTFASTCANTCLIP
  em = "A DirectDrawClipper object is attached to a source surface that has passed into a call to the IDirectDrawSurface2::BltFast method."
  Case DDERR_CANNOTATTACHSURFACE
  em = "A surface cannot be attached to another requested surface."
  Case DDERR_CANNOTDETACHSURFACE
  em = "A surface cannot be detached from another requested surface."
  Case DDERR_CANTCREATEDC
  em = "Windows cannot create any more device contexts (DCs)."
  Case DDERR_CANTDUPLICATE
  em = "Primary and 3D surfaces, or surfaces that are implicitly created, cannot be duplicated."
  Case DDERR_CANTLOCKSURFACE
  em = "Access to this surface is refused because an attempt was made to lock the primary surface without DCI support."
  Case DDERR_CANTPAGELOCK
  em = "An attempt to page lock a surface failed. Page lock will not work on a display-memory surface or an emulated primary surface."
  Case DDERR_CANTPAGEUNLOCK
  em = "An attempt to page unlock a surface failed. Page unlock will not work on a display-memory surface or an emulated primary surface."
  Case DDERR_CLIPPERISUSINGHWND
  em = "An attempt was made to set a clip list for a DirectDrawClipper object that is already monitoring a window handle."
  Case DDERR_COLORKEYNOTSET
  em = "No source color key is specified for this operation."
  Case DDERR_CURRENTLYNOTAVAIL
  em = "No support is currently available."
  Case DDERR_DCALREADYCREATED
  em = "A device context (DC) has already been returned for this surface. Only one DC can be retrieved for each surface."
  Case DDERR_DIRECTDRAWALREADYCREATED
  em = "A DirectDraw object representing this driver has already been created for this process."
  Case DDERR_EXCEPTION
  em = "An exception was encountered while performing the requested operation."
  Case DDERR_EXCLUSIVEMODEALREADYSET
  em = "An attempt was made to set the cooperative level when it was already set to exclusive."
  'Case DDERR_GENERIC
  'em = "There is an undefined error condition."
  Case DDERR_HEIGHTALIGN
  em = "The height of the provided rectangle is not a multiple of the required alignment."
  Case DDERR_HWNDALREADYSET
  em = "The DirectDraw cooperative level window handle has already been set. It cannot be reset while the process has surfaces or palettes created."
  Case DDERR_HWNDSUBCLASSED
  em = "DirectDraw is prevented from restoring state because the DirectDraw cooperative level window handle has been subclassed."
  Case DDERR_IMPLICITLYCREATED
  em = "The surface cannot be restored because it is an implicitly created surface."
  Case DDERR_INCOMPATIBLEPRIMARY
  em = "The primary surface creation request does not match with the existing primary surface."
  Case DDERR_INVALIDCAPS
  em = "One or more of the capability bits passed to the callback function are incorrect."
  Case DDERR_INVALIDCLIPLIST
  em = "DirectDraw does not support the provided clip list."
  Case DDERR_INVALIDDIRECTDRAWGUID
  em = "The globally unique identifier (GUID) passed to the DirectDrawCreate function is not a valid DirectDraw driver identifier."
  Case DDERR_INVALIDMODE
  em = "DirectDraw does not support the requested mode."
  Case DDERR_INVALIDOBJECT
  em = "DirectDraw received a pointer that was an invalid DirectDraw object."
  'Case DDERR_INVALIDPARAMS
  'em = "One or more of the parameters passed to the method are incorrect."
  Case DDERR_INVALIDPIXELFORMAT
  em = "The pixel format was invalid as specified."
  Case DDERR_INVALIDPOSITION
  em = "The position of the overlay on the destination is no longer legal."
  Case DDERR_INVALIDRECT
  em = "The provided rectangle was invalid."
  Case DDERR_INVALIDSURFACETYPE
  em = "The requested operation could not be performed because the surface was of the wrong type."
  Case DDERR_LOCKEDSURFACES
  em = "One or more surfaces are locked, causing the failure of the requested operation."
  Case DDERR_NO3D
  em = "No 3D hardware or emulation is present."
  Case DDERR_NOALPHAHW
  em = "No alpha acceleration hardware is present or available, causing the failure of the requested operation."
  Case DDERR_NOBLTHW
  em = "No blitter hardware is present."
  Case DDERR_NOCLIPLIST
  em = "No clip list is available."
  Case DDERR_NOCLIPPERATTACHED
  em = "No DirectDrawClipper object is attached to the surface object."
  Case DDERR_NOCOLORCONVHW
  em = "The operation cannot be carried out because no color-conversion hardware is present or available."
  Case DDERR_NOCOLORKEY
  em = "The surface does not currently have a color key."
  Case DDERR_NOCOLORKEYHW
  em = "The operation cannot be carried out because there is no hardware support for the destination color key."
  Case DDERR_NOCOOPERATIVELEVELSET
  em = "A create function is called without the IDirectDraw2::SetCooperativeLevel method being called."
  Case DDERR_NODC
  em = "No DC has ever been created for this surface."
  Case DDERR_NODDROPSHW
  em = "No DirectDraw raster operation (ROP) hardware is available."
  Case DDERR_NODIRECTDRAWHW
  em = "Hardware-only DirectDraw object creation is not possible; the driver does not support any hardware."
  Case DDERR_NODIRECTDRAWSUPPORT
  em = "DirectDraw support is not possible with the current display driver."
  Case DDERR_NOEMULATION
  em = "Software emulation is not available."
  Case DDERR_NOEXCLUSIVEMODE
  em = "The operation requires the application to have exclusive mode, but the application does not have exclusive mode."
  Case DDERR_NOFLIPHW
  em = "Flipping visible surfaces is not supported."
  Case DDERR_NOGDI
  em = "No GDI is present."
  Case DDERR_NOHWND
  em = "Clipper notification requires a window handle, or no window handle has been previously set as the cooperative level window handle."
  Case DDERR_NOMIPMAPHW
  em = "The operation cannot be carried out because no mipmap texture mapping hardware is present or available."
  Case DDERR_NOMIRRORHW
  em = "The operation cannot be carried out because no mirroring hardware is present or available."
  Case DDERR_NOOVERLAYDEST
  em = "The IDirectDrawSurface2::GetOverlayPosition method is called on an overlay that the IDirectDrawSurface2::UpdateOverlay method has not been called on to establish a destination."
  Case DDERR_NOOVERLAYHW
  em = "The operation cannot be carried out because no overlay hardware is present or available."
  Case DDERR_NOPALETTEATTACHED
  em = "No palette object is attached to this surface."
  Case DDERR_NOPALETTEHW
  em = "There is no hardware support for 16- or 256-color palettes."
  Case DDERR_NORASTEROPHW
  em = "The operation cannot be carried out because no appropriate raster operation hardware is present or available."
  Case DDERR_NOROTATIONHW
  em = "The operation cannot be carried out because no rotation hardware is present or available."
  Case DDERR_NOSTRETCHHW
  em = "The operation cannot be carried out because there is no hardware support for stretching."
  Case DDERR_NOT4BITCOLOR
  em = "The DirectDrawSurface object is not using a 4-bit color palette and the requested operation requires a 4-bit color palette."
  Case DDERR_NOT4BITCOLORINDEX
  em = "The DirectDrawSurface object is not using a 4-bit color index palette and the requested operation requires a 4-bit color index palette."
  Case DDERR_NOT8BITCOLOR
  em = "The DirectDrawSurface object is not using an 8-bit color palette and the requested operation requires an 8-bit color palette."
  Case DDERR_NOTAOVERLAYSURFACE
  em = "An overlay component is called for a non-overlay surface."
  Case DDERR_NOTEXTUREHW
  em = "The operation cannot be carried out because no texture-mapping hardware is present or available."
  Case DDERR_NOTFLIPPABLE
  em = "An attempt has been made to flip a surface that cannot be flipped."
  Case DDERR_NOTFOUND
  em = "The requested item was not found."
  Case DDERR_NOTINITIALIZED
  em = "An attempt was made to call an interface method of a DirectDraw object created by CoCreateInstance before the object was initialized."
  Case DDERR_NOTLOCKED
  em = "An attempt is made to unlock a surface that was not locked."
  Case DDERR_NOTPAGELOCKED
  em = "An attempt is made to page unlock a surface with no outstanding page locks."
  Case DDERR_NOTPALETTIZED
  em = "The surface being used is not a palette-based surface."
  Case DDERR_NOVSYNCHW
  em = "The operation cannot be carried out because there is no hardware support for vertical blank synchronized operations."
  Case DDERR_NOZBUFFERHW
  em = "The operation to create a z-buffer in display memory or to perform a blit using a z-buffer cannot be carried out because there is no hardware support for z-buffers."
  Case DDERR_NOZOVERLAYHW
  em = "The overlay surfaces cannot be z-layered based on the z-order because the hardware does not support z-ordering of overlays."
  Case DDERR_OUTOFCAPS
  em = "The hardware needed for the requested operation has already been allocated."
  'Case DDERR_OUTOFMEMORY
  'em = "DirectDraw does not have enough memory to perform the operation."
  Case DDERR_OUTOFVIDEOMEMORY
  em = "DirectDraw does not have enough display memory to perform the operation."
  Case DDERR_OVERLAYCANTCLIP
  em = "The hardware does not support clipped overlays."
  Case DDERR_OVERLAYCOLORKEYONLYONEACTIVE
  em = "An attempt was made to have more than one color key active on an overlay."
  Case DDERR_OVERLAYNOTVISIBLE
  em = "The IDirectDrawSurface2::GetOverlayPosition method is called on a hidden overlay."
  Case DDERR_PALETTEBUSY
  em = "Access to this palette is refused because the palette is locked by another thread."
  Case DDERR_PRIMARYSURFACEALREADYEXISTS
  em = "This process has already created a primary surface."
  Case DDERR_REGIONTOOSMALL
  em = "The region passed to the IDirectDrawClipper::GetClipList method is too small."
  Case DDERR_SURFACEALREADYATTACHED
  em = "An attempt was made to attach a surface to another surface to which it is already attached."
  Case DDERR_SURFACEALREADYDEPENDENT
  em = "An attempt was made to make a surface a dependency of another surface to which it is already dependent."
  Case DDERR_SURFACEBUSY
  em = "Access to the surface is refused because the surface is locked by another thread."
  Case DDERR_SURFACEISOBSCURED
  em = "Access to the surface is refused because the surface is obscured."
  Case DDERR_SURFACELOST
  em = "Access to the surface is refused because the surface memory is gone. The DirectDrawSurface object representing this surface should have the IDirectDrawSurface2::Restore method called on it."
  Case DDERR_SURFACENOTATTACHED
  em = "The requested surface is not attached."
  Case DDERR_TOOBIGHEIGHT
  em = "The height requested by DirectDraw is too large."
  Case DDERR_TOOBIGSIZE
  em = "The size requested by DirectDraw is too large. However, the individual height and width are OK."
  Case DDERR_TOOBIGWIDTH
  em = "The width requested by DirectDraw is too large."
  'Case DDERR_UNSUPPORTED
  'em = "The operation is not supported."
  Case DDERR_UNSUPPORTEDFORMAT
  em = "The FourCC format requested is not supported by DirectDraw."
  Case DDERR_UNSUPPORTEDMASK
  em = "The bitmask in the pixel format requested is not supported by DirectDraw."
  Case DDERR_UNSUPPORTEDMODE
  em = "The display is currently in an unsupported mode."
  Case DDERR_VERTICALBLANKINPROGRESS
  em = "A vertical blank is in progress."
  Case DDERR_WASSTILLDRAWING
  em = "The previous blit operation that is transferring information to or from this surface is incomplete."
  Case DDERR_WRONGMODE
  em = "This surface cannot be restored because it was created in a different mode."
  Case DDERR_XALIGN
  em = "The provided rectangle was not horizontally aligned on a required boundary."
  Case Else
  em = "UNKNOW ERROR!!! OutOfMemory or INFAILED PARAMETERS" + Str$(ErrorCode) & " " & Hex$(ErrorCode) & " " & Err.Description
End Select
MsgBox em, vbCritical, ErrorTitle
If ErrorFlag = True Then
  Unload frmMain
  End
End If
End Sub
Public Sub D3DRMERROR(ByVal ErrorCode As Long, _
                      ByVal ErrorTitle As String, _
                      ByVal ErrorFlag As Boolean)
Dim em As String
On Error Resume Next

Select Case ErrorCode
  Case D3DRMERR_BADALLOC
  em = "Out of memory."
  Case D3DRMERR_BADDEVICE
  em = "Device is not compatible with renderer."
  Case D3DRMERR_BADFILE
  em = "Data file is corrupt."
  Case D3DRMERR_BADMAJORVERSION
  em = "Bad DLL major version."
  Case D3DRMERR_BADMINORVERSION
  em = "Bad DLL minor version."
  Case D3DRMERR_BADOBJECT
  em = "Object expected in argument."
  Case D3DRMERR_BADTYPE
  em = "Bad argument type passed."
  Case D3DRMERR_BADVALUE
  em = "Bad argument value passed."
  Case D3DRMERR_FACEUSED
  em = "Face already used in a mesh."
  Case D3DRMERR_FILENOTFOUND
  em = "File cannot be opened."
  Case D3DRMERR_NOTDONEYET
  em = "Unimplemented."
  Case D3DRMERR_NOTFOUND
  em = "Object not found in specified place."
  Case D3DRMERR_UNABLETOEXECUTE
  em = "Unable to carry out procedure."
  Case Else
  em = "UNKNOW D3DRMError! " & Str$(ErrorCode) & " " & Str$(Err.Number) & " " & Hex$(Err.Number)
  End Select
  MsgBox em, vbCritical, ErrorTitle
  If ErrorFlag = True Then
    Unload frmMain
    End
  End If
End Sub

