Attribute VB_Name = "modDirectXHelper"
Option Explicit

Public Type MODE_TYPE
  Width       As Long
  Xm          As Long
  ZoomX       As Single
  Height      As Long
  Ym          As Long
  ZoomY       As Single
  BPP         As Long
  TotalColors As Long
End Type

Public Type DRIVER_TYPE
  DESC    As String
  NAME    As String
  GUID    As Byte
  GUID1   As Byte
  GUID2   As Byte
  GUID3   As Byte
  GUID4   As Byte
  GUID5   As Byte
  GUID6   As Byte
  GUID7   As Byte
  GUID8   As Byte
  GUID9   As Byte
  GUID10  As Byte
  GUID11  As Byte
  GUID12  As Byte
  GUID13  As Byte
  GUID14  As Byte
  GUID15  As Byte
  DEVDESC As D3DDEVICEDESC
  HDW     As Boolean
  EMU     As Boolean
  RGB     As Boolean
  MONO    As Boolean
End Type

Public Enum D3DRMANIMATIONOPTIONS
  D3DRMANIMATION_CLOSED = &H2&
  D3DRMANIMATION_LINEARPOSITION = &H4&
  D3DRMANIMATION_OPEN = &H1&
  D3DRMANIMATION_POSITION = &H20&
  D3DRMANIMATION_SCALEANDROTATION = &H10&
  D3DRMANIMATION_SPLINEPOSITION = &H8&
End Enum

Public Enum D3DRMMAPPINGFLAG
  D3DRMMAP_WRAPU = 1
  D3DRMMAP_WRAPV = 2
  D3DRMMAP_PERSPCORRECT = 4
End Enum
  
Public Const PI As Single = 3.1415927
Public Const PIm2 As Single = PI * 2

Public Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByVal source As Long, ByVal length As Long)

Public Const GDC_WIDTH       As Long = &H8&
Public Const GDC_HEIGHT      As Long = &HA&
Public Const GDC_BitPerPixel As Long = &HC&
Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long

Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal Col As Long) As Long

Public Declare Function GetDC Lib "user32" (ByVal hWND As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWND As Long, ByVal hdc As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hdc As Long, ByVal First As Long, ByVal Size As Long, ptr As Any) As Long

Public Const MAX_MODE        As Long = 30
Global VideoModes(MAX_MODE)  As MODE_TYPE
Public NumOfModes            As Long
Global CurMode               As Long

Public Const MAX_DRIVER      As Long = 5
Public Drivers(MAX_DRIVER)   As DRIVER_TYPE
Public NumOfDrivers          As Long
Public CurDriver             As Long
Public gDDSDESCTMP           As DDSURFACEDESC
Public BPP                   As Long
Public Function ApplicationPath() As String
  ApplicationPath = IIf(Right$(App.Path, 1) = "\", App.Path, App.Path & "\")
End Function

Public Function BPPToDDBD(ByVal BitPerPixel As Long) As Long
  Select Case BitPerPixel
    Case 1
      BPPToDDBD = DDBD_1
    Case 2
      BPPToDDBD = DDBD_2
    Case 4
      BPPToDDBD = DDBD_4
    Case 8
      BPPToDDBD = DDBD_8
    Case 16
      BPPToDDBD = DDBD_16
    Case 24
      BPPToDDBD = DDBD_24
    Case 32
      BPPToDDBD = DDBD_32
    Case Else
      BPPToDDBD = 0
  End Select
End Function
Function EnumDeviceCallback(lpGUID As Long, _
                            lpDevDesc As Long, _
                            lpDevName As Long, _
                            HDWDevDesc As D3DDEVICEDESC, _
                            HELDevDesc As D3DDEVICEDESC, _
                            lpUserArg As Long) As Long
  
  Dim TMP(256) As Byte
  Dim Char     As Byte
  Dim i        As Long
  
  If NumOfDrivers > MAX_DRIVER Then
    EnumDeviceCallback = DDENUMRET_CANCEL
    Exit Function
  End If

  With Drivers(NumOfDrivers)
    If HDWDevDesc.dcmColorModel Then
      .DEVDESC = HDWDevDesc
      .HDW = True
    Else
      .DEVDESC = HELDevDesc
    End If
    
    'is it in hardware and support for RGB
    .RGB = IIf(.DEVDESC.dcmColorModel = D3DCOLOR_RGB, True, False)
    .EMU = Not .HDW
    .MONO = Not .RGB
    
    'skip it
    If 0 = (.DEVDESC.dwDeviceRenderBitDepth And BPPToDDBD(BPP)) Then
      EnumDeviceCallback = DDENUMRET_OK
      GoTo ExitEnumDevicesCallback
    End If
    
    'GUID
    CopyMemory VarPtr(TMP(0)), VarPtr(lpGUID), 16
  
    .GUID = TMP(0)
    .GUID1 = TMP(1)
    .GUID2 = TMP(2)
    .GUID3 = TMP(3)
    .GUID4 = TMP(4)
    .GUID5 = TMP(5)
    .GUID6 = TMP(6)
    .GUID7 = TMP(7)
    .GUID8 = TMP(8)
    .GUID9 = TMP(9)
    .GUID10 = TMP(10)
    .GUID11 = TMP(11)
    .GUID12 = TMP(12)
    .GUID13 = TMP(13)
    .GUID14 = TMP(14)
    .GUID15 = TMP(15)
  
  
    'Name
    CopyMemory VarPtr(TMP(0)), VarPtr(lpDevName), 255
    For i = 0 To 255
      Char = TMP(i): If Char < 32 Then Exit For
      .NAME = .NAME + Chr$(Char)
    Next
  
    'Description
    CopyMemory VarPtr(TMP(0)), VarPtr(lpDevDesc), 255
    For i = 0 To 255
      Char = TMP(i): If Char < 32 Then Exit For
      .DESC = .DESC + Chr$(Char)
    Next
  
  End With
  
  NumOfDrivers = NumOfDrivers + 1
  EnumDeviceCallback = DDENUMRET_OK

ExitEnumDevicesCallback:

End Function

Function EnumModesCallback(EnumDDSD As DDSURFACEDESC, lpVOID As Long) As Long
  If NumOfModes > MAX_MODE Then
    EnumModesCallback = DDENUMRET_CANCEL
  Else
    VideoModes(NumOfModes).Width = EnumDDSD.dwWidth
    VideoModes(NumOfModes).Xm = VideoModes(NumOfModes).Width \ 2
    VideoModes(NumOfModes).ZoomX = VideoModes(NumOfModes).Width * 0.8
    VideoModes(NumOfModes).Height = EnumDDSD.dwHeight
    VideoModes(NumOfModes).Ym = VideoModes(NumOfModes).Height \ 2
    VideoModes(NumOfModes).ZoomY = VideoModes(NumOfModes).Height
    VideoModes(NumOfModes).BPP = EnumDDSD.ddpfPixelFormat.dwRGBBitCount
    VideoModes(NumOfModes).TotalColors = 2 ^ VideoModes(NumOfModes).BPP
    NumOfModes = NumOfModes + 1
    EnumModesCallback = DDENUMRET_OK
  End If
End Function

' Creates a DirectDraw2 surface from a file
' See in DirectX SDK misc\ddutil
Sub CreateSurfaceFromFile(DD2 As DirectDraw2, _
                          DDS As DirectDrawSurface2, _
                          FRM As Form, _
                          ByVal Width As Long, _
                          ByVal Height As Long, _
                          ByVal strFile As String)
  
  Dim PIC As New StdPicture
  Dim hDC_PIC As Long
  Dim PIC_Width As Long
  Dim PIC_Height As Long
  
  Dim DDSD As DDSURFACEDESC
  Dim hDC_Surface As Long
  
  
  Set PIC = LoadPicture(strFile)
  
  PIC_Width = FRM.ScaleX(PIC.Width, vbHimetric, vbPixels)
  PIC_Height = FRM.ScaleY(PIC.Height, vbHimetric, vbPixels)
  If Width = 0 Then Width = PIC_Width
  If Height = 0 Then Height = PIC_Height
  
  With DDSD
      .dwSize = Len(DDSD)
      .dwFlags = DDSD_CAPS Or _
                 DDSD_HEIGHT Or _
                 DDSD_WIDTH
      .DDSCAPS.dwCaps = DDSCAPS_OFFSCREENPLAIN Or _
                        DDSCAPS_SYSTEMMEMORY
      .dwWidth = Width
      .dwHeight = Height
  End With
  
  DD2.CreateSurface DDSD, DDS, Nothing
  hDC_PIC = CreateCompatibleDC(ByVal 0&)
  SelectObject hDC_PIC, PIC.Handle
  DDS.Restore
  DDS.GetDC hDC_Surface
  StretchBlt hDC_Surface, 0, 0, Width, Height, hDC_PIC, 0, 0, PIC_Width, PIC_Height, vbSrcCopy
  DDS.ReleaseDC hDC_Surface
  DeleteDC hDC_PIC
   
End Sub
Public Function ColMatch(DDS2 As DirectDrawSurface2, _
                         ByVal Col As Long) As Long
   Dim DDS2D       As DDSURFACEDESC
   Dim DDLOCK_FLAG As Long
   Dim hdc         As Long
   Dim SaveRGB     As Long
   Dim va(0)       As Long
   DDS2D.dwSize = Len(DDS2D)
   
   DDS2.GetDC hdc
   'save original pixel
   SaveRGB = GetPixel(hdc, 0, 0)
   'set new color
   SetPixel hdc, 0, 0, Col
   DDS2.ReleaseDC hdc
   DDLOCK_FLAG = DDLOCK_READONLY Or DDLOCK_SURFACEMEMORYPTR Or DDLOCK_WAIT
   DDS2.Lock ByVal 0&, DDS2D, 0, DDLOCK_FLAG
   CopyMemory ByVal VarPtr(va(0)), ByVal DDS2D.lpSurface, 4
   DDS2.Unlock ByVal 0&
   'Build new mask for colorkey
   ColMatch = va(0) And (2 ^ DDS2D.ddpfPixelFormat.dwRGBBitCount) - 1
   
   'restore old pixel
   DDS2.GetDC hdc
   SetPixel hdc, 0, 0, SaveRGB
   DDS2.ReleaseDC hdc

End Function

Public Sub SetColKey(DDS2 As DirectDrawSurface2, _
                     Col As Long)
   Dim CK As DDCOLORKEY
   CK.dwColorSpaceLowValue = ColMatch(DDS2, Col)
   CK.dwColorSpaceHighValue = CK.dwColorSpaceLowValue
   DDS2.SetColorKey DDCKEY_SRCBLT, CK
End Sub


